<?php
 /*
   Tiquit Is Quality User Incident Tracking
   Copyright (C) 2006 Jonathan Ciesla
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
  */
require_once("config.php");
require_once("functionlib.php");
session_start();
favicon();

?>
<script language="JavaScript" type="text/javascript">
<!--
  function box_onload() {
    document.forms[0].elements[0].focus();
  }
// -->
</script>
<?

$link = dbms_connect($dbhost, $dbuser, $dbpass, $dbname);

$logout = $_POST['logout'];
if($logout){
  unset($_SESSION['tiquitadmin']);
  unset($_SESSION['tiquitstate']);
  unset($_SESSION['tiquitid']);
 };

$login=$_POST['login'];
if($login=="yes"){
  $id = $_POST['id'];
  $pass = $_POST['pass'];
  $query = "SELECT password,admin FROM agent WHERE id = '$id'";
  $result = dbms_query($query);
  $line = dbms_fetch_array($result, "ASSOC");
  dbms_free_result($result);
  $nimba = $line['password'];
  $admin_level = $line['admin'];
  $salt = substr($id, 0, 2);
  $pass = crypt($pass, $salt);
  if ($nimba == $pass){ 
    $_SESSION['tiquitid'] = $id;
    $_SESSION['tiquitstate'] = "in";
    $_SESSION['tiquitadmin'] = $admin_level;
  } else {
    $error = 1;
  };
 };

if((!isset($_SESSION['tiquitstate']))||(!isset($_SESSION['tiquitid']))){
  echo "<body onload=\"box_onload();\">";
  echo "<link rel=stylesheet href=style.css>";
  echo "<a href=\"http://tiquit.sourceforge.net\" target=\"_blank\">";
  echo "<img src=\"tiquit_logo_grey.png\" border=0></a><br />";
  
  echo "<table align=center border=2 cellpadding=5>";
  echo "<form action=main.php method=post>";
  echo "<td align=right>Agent ID:<input type=text name=id></td>";
  echo "</tr><tr>";
  echo "<td align=right>Password:<input type=password name=pass></td>";
  echo "</tr><tr>";
  echo "<td align=center><input type=hidden name=login value=yes>";
  echo "<input type=submit value=Login ></td>"; 
  echo "</form>";
  echo "</tr></table>";
  echo "<br />";
  if($error==1){echo "Invalid ID or Password.<br />";};
  echo "<meta http-equiv=refresh content=30;url=$siteaddress/index.php />";
 } else {     
  echo "<link rel=stylesheet href=css.php>";
  $user_id = $_SESSION['tiquitid'];
  $admin_level =$_SESSION['tiquitadmin'];
  
  $date_a = array(date("Y"), date("m"), date("d"));
  $date = implode("-", $date_a);
  $query1 = "UPDATE agent SET ll = '$date' WHERE id = '$user_id'";
  $result1 = dbms_query($query1);
  echo "<meta http-equiv=refresh content=300 />";
  
  $updatenew=$_POST['updatenew'];
  if($updatenew=="yes"){
    $date_a = array(date("Y"), date("m"), date("d"));
    $datenew = implode("-", $date_a);
    $time_a = array(date("H"), date("i"), date("s"));
    $time = implode(":", $time_a);
    $datenew = $datenew . " " . $time;
    
    $query = "SELECT number FROM incident ORDER BY number DESC LIMIT 1;";
    $result = dbms_query($query);
    $line = dbms_fetch_array($result, "NUM");
    $num = $line[0];
    $num++;
    dbms_free_result($result);
    
    $user = $_POST['name'];
    $type = $_POST['type'];
    $agent = $_POST['agent'];
    $description = $_POST['description'];
    $status = $_POST['status'];
    $parenttext = $_POST['parenttext'];
    if($parenttext){
      $parent=dbms_escape_string($parenttext);
    } else { 
      $parent = $_POST['parent'];
    };
    
    if($parent==$num){$parent=="";};
    
    $newparent = $parent;
    while($newparent){
      $query = "SELECT parent FROM incident WHERE number = '$newparent';";
      $result = dbms_query($query);
      $line = dbms_fetch_array($result, "NUM");
      if($line[0]){
	if($newparent==$line[0]){$line[0]=="";};
	$newparent = $line[0];
      } else {
	$parent = $newparent;
	$newparent = "";
      };
      dbms_free_result($result);
    };
    
    if(!$status){$status="Open";};
    $resolution = $_POST['resolution'];
    if($status=="Closed"){$closed=$datenew;}else{$closed="";};
    $severity = $_POST['severity'];
    
    $user=dbms_escape_string($user);
    $type=dbms_escape_string($type);
    $agent=dbms_escape_string($agent);
    $description=dbms_escape_string($description);
    $status=dbms_escape_string($status);
    $resolution=dbms_escape_string($resolution);
    $datenew = dbms_escape_string($datenew);
    $closed = dbms_escape_string($closed);
    $severity = dbms_escape_string($severity);
    
    if (($type)&&($user)&&($description)) {
      $query = "INSERT INTO incident (number,type,usr,agent,description,status,resolution,date,closed,severity,parent) VALUES ('$num','$type','$user',";
      if($agent){$query .= "'$agent'";}else{$query .= "NULL";};
      $query .= ",'$description','$status','$resolution','$datenew',";
      if($closed){$query .= "'$closed'";}else{$query .= "NULL";};
      $query .= ",'$severity',";
      if($parent){$query .= "'$parent'";}else{$query .= "NULL";};
      $query .= ");";
      $result = dbms_query($query, $link);
      
      $query = "SELECT lname,fname FROM users WHERE number = '$user';";
      $result = dbms_query($query, $link);
      $line = dbms_fetch_array($result, "ASSOC");
      $fname = $line['fname']; $lname = $line['lname'];
      dbms_free_result($result);
      
      $rep = agent_name($agent);
      
      //notification
      
      $query = "SELECT notify,address,name FROM universal";
      $result = dbms_query($query);
      $line = dbms_fetch_array($result, "ASSOC");
      dbms_free_result($result);
      if($line['notify']=="1"){
	$sender = $line['address'];
	$from = "-f" . $sender;
	$name = $line['name'];

	$query = "SELECT email FROM users WHERE number = '$user'";
	$result = dbms_query($query);
	$line = dbms_fetch_array($result, "ASSOC");
	dbms_free_result($result);
	$user_email = $line['email'];
	
	$type_name = type_name($type);
	
	$query1 = "SELECT name FROM agent WHERE id ='$user_id'";
	$result1 = dbms_query($query1);
	$line1 = dbms_fetch_array($result1, "ASSOC");
	dbms_free_result($result1);
	$agent_name = $line1['name'];
	
	$query1 = "SELECT name,email FROM agent WHERE number = '$agent'";
	$result1 = dbms_query($query1);
	$line1 = dbms_fetch_array($result1, "ASSOC");
	dbms_free_result($result1);
	$assignee_name = $line1['name'];
	$agent_email = $line1['email'];
	
	$sub = "Tiquit Incident # $num";
	
	$message = "<html>";
	$message .= "<h2><b>New Incident # $num for:</b> $fname $lname</h2>";
	$message .= "<h3><b>Type:</b> $type_name</h3>";
	$message .= "<h3><b>Severity:</b> $severity</h3>";
	if($parent){
	  $message .= "<h3><b>Parent Incident:</b> $parent</h3>";
	};
	$message .= "<h3><b>Assigned by:</b> $agent_name</h3>";
	$message .= "<h3><b>Assigned to:</b> $assignee_name</h3>";
	$message .= "<h4><b>Description:</b> $description</h4>";
	$addy = $siteaddress . "/index.php?name=" . $user;
	$message .= "<p>Click <a href=$addy>here</a> to view your incidents";
	$headers = "From: $name <$sender>\r\n";
	$headers .= "Reply-to: $sender\r\n";
	$headers .= "Cc: $user_email\r\n";
	$headers .= "MIME-Version: 1.0\r\n";
	$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
	
	mail($agent_email, $sub, $message, $headers, $from);
      };
    };
  };
  
  echo "<title>$sitetitle</title>";
  echo "<h1>$sitetitle</h1>";
  $query2 ="SELECT name FROM agent WHERE id = '$user_id'";
  $result2 = dbms_query($query2);
  $line = dbms_fetch_array($result2, "NUM");
  dbms_free_result($result2);
  $fname = $line[0];
  
  $incident=$_POST['incident'];
  $query = "DELETE FROM locks WHERE id = '$user_id';";
  $result = dbms_query($query);
  
  echo "<table border=1 align=center>";
  
  echo "<tr>";
  echo "<th>Incident</th>";
  echo "<td align=center>";
  echo "<form action=main.php method=post>";
  echo "<input type=submit value=\"Incidents for $fname\">";
  echo "</form>";
  echo "</td>";
  $query = "SELECT COUNT(number) FROM incident WHERE agent IS NULL;";
  $result = dbms_query($query);
  $line = dbms_fetch_array($result, "NUM");
  dbms_free_result($result);
  if($line[0]>0){$flag = "bgcolor=#FFFF00";}else{$flag="";};
  echo "<td align=center $flag>";
  echo "<form action=unassigned.php method=post>";
  echo "<input type=submit value=\"Unassigned Incidents\">";
  echo "</form>";
  echo "</td>";


  echo "<th>Admin</th></tr>";
  
  echo "<tr>";
  
  echo "<td align=right>";
  echo "<form action=name_select.php method=post>";
  echo "<input type=hidden name=form value=search>";
  echo "<input type=submit value=\"Lookup By:\"><br />";
  
  name_widget(1);
   
  echo "<select name=type />";
  echo "<option value=\"\">Type:";
  $query = "SELECT name,number FROM type WHERE enabled = '1';";
  $result = dbms_query($query);
  while ($line = dbms_fetch_array($result, "NUM")) {
    echo "<option value={$line['1']}>{$line['0']}";
  };
  dbms_free_result($result);
  
  echo "</select><br />";
  
  echo "<select name=agent />";
  echo "<option value=\"\">Agent:";
  $query = "SELECT name,number FROM agent WHERE enabled = '1';";
  $result = dbms_query($query);
  while ($line = dbms_fetch_array($result, "NUM")) {
    echo "<option value={$line['1']}>{$line['0']}";
  };
  dbms_free_result($result);
  
  echo "</select><br />";
  echo "</form>";
  echo "</td>";
  
  echo "<td align=center>";
  echo "<form action=incident_new.php method=post>";
  echo "<input type=submit value=\"Enter New Incident\">";
  echo "</form>";
  echo "</td><td align=center>";
  echo "<form action=incident_update.php method=post>";
  echo "<input type=submit value=\"Update Incident #\">";
  echo "<input type=text name=numtext size=5 />";
  $query = "SELECT number FROM incident ORDER BY number DESC LIMIT 10";
  $result = dbms_query($query);
  echo "<select name=num>";
  echo "<option value =\"\">";
  while($line = dbms_fetch_array($result, "NUM")){
    echo "<option value={$line['0']}>{$line['0']}";
  };
  dbms_free_result($result);
  echo "</select>";
  echo "</form>";
  echo "</td>";
  
  echo "<td rowspan=4 align=center valign=top>";
  
  if($admin_level>="2"){
    echo "<form action=univ.php method=post>";
    echo "<input type=submit value=Configuration>";
    echo "</form>";
    
    echo "<form action=agent.php method=post>";
    echo "<input type=submit value=\"Agent Manager\">";
    echo "</form>";
    
    echo "<form action=location.php method=post>";
    echo "<input type=submit value=\"Location Manager\">";
    echo "</form>";
    
    echo "<form action=type.php method=post>";
    echo "<input type=submit value=\"Incident Type Manager\">";
    echo "</form>";
  };
  
  if($admin_level>="1"){
    echo "<form action=user.php method=post>";
    echo "<input type=submit value=\"User Manager\">";
    echo "</form>";
  };

  echo "<form action=knowledgebase.php method=post>";
  echo "<input type=submit value=\"Knowledgebase\">";
  echo "</form>";
  
  echo "<form action=pass.php method=post>";
  echo "<input type=submit value=\"Change Password\">";
  echo "</form>";
  
  echo "<form action=reporting.php method=post>";
  echo "<input type=submit value=\"Reporting\">";
  echo "</form>";
  
  echo "<form action=main.php method=post>";
  echo "<input type=hidden name=logout value=yes>";
  echo "<input type=submit value=\"Log Out\">";
  echo "</form>";
  
  echo "</td></tr>";
  
  echo "<tr><td align=right>";
  echo "<form action=search_incident_text.php method=post>";
  echo "<input type=submit value=\"Search by Keyword(s)\"><br />";
  echo "<input type=text name=keyword><br />";
  echo "In fields:<br />";
  echo "Description<input type=checkbox name=desc checked><br />";
  echo "Diary Entries<input type=checkbox name=diary><br />";
  echo "Resolution<input type=checkbox name=resol><br />";
  echo "</form>";
  echo "</td>";
  
  echo "<td rowspan=3 colspan=2 align=center>";
  
  $query = "SELECT number FROM agent WHERE id ='$user_id'";
  $result = dbms_query($query);
  $line = dbms_fetch_array($result, "NUM");
  $id = $line[0];
  dbms_free_result($result);
  
  echo "<table border=1 align=center>";
  echo "<tr><th>#</th><th>User</th><th>Severity</th><th>Type</th><th width=300>Description</th><th>Date</th><th>Status</th></tr>";
  $query = "SELECT number,usr,type,description,date,status,severity FROM incident WHERE agent = '$id' AND status <> 'Closed' ORDER BY status DESC, severity ASC, number DESC";
  $result = dbms_query($query);
  while($line = dbms_fetch_array($result, "ASSOC")){
    echo "<tr>";
    
    if($line['status']=="Open"){$stat_color = "#00FF00";};
    if($line['status']=="Hold"){$stat_color = "#FFFF00";};
    
    echo "<td bgcolor=$stat_color>{$line['number']}</td>";
    
    $query1 = "SELECT lname,fname FROM users WHERE number = '{$line['usr']}'";
    $result1 = dbms_query($query1);
    $line1 = dbms_fetch_array($result1, "ASSOC");
    dbms_free_result($result1);
    $print_name = $line1['lname'] . ", " . $line1['fname'];
    echo "<td bgcolor=$stat_color>$print_name</td>";
    
    if($line['severity']=="1"){$sev_color = "#FF0000";};
    if($line['severity']=="2"){$sev_color = "#FF9900";};
    if($line['severity']=="3"){$sev_color = "#FFFF00";};
    if($line['severity']=="4"){$sev_color = "#00FF00";};
    if($line['severity']=="5"){$sev_color = "#0000FF";};
    
    echo "<td bgcolor=$sev_color align=center>{$line['severity']}</td>";
    
    $print_type = type_name($line['type']);
    echo "<td bgcolor=$stat_color>$print_type</td>";
    
    $wrapped = wordwrap($line['description'], 45, "<br />\n", 1);
    
    echo "<td bgcolor=$stat_color>$wrapped</td>";
    
    echo "<td bgcolor=$stat_color>{$line['date']}</td>";
    
    echo "<td bgcolor=$stat_color>";
    echo "<form action=incident_update.php method=post>";
    echo "<input type=hidden name=num value=\"{$line['number']}\">";
    echo "<input type=submit value={$line['status']}>";
    echo "</form>";
    echo "</td>";
    
    echo "</tr>";
  };
  echo "</table>";
  dbms_free_result($result);
  
  echo "</td>";
  
  echo "<tr><td align=right>";
  echo "<form action=search_incident_date.php method=post>";
  echo "<input type=submit value=\"Search by Date\"><br />";
  echo "Initial<input type=text name=date1 size=10><br />";
  echo "Secondary<input type=text name=date2 size=10><br />";
  echo "</form>";
  echo "Format: YYYY-MM-DD";
  echo "</td></tr>";
  
  echo "</table>";
 };

$query = "SELECT version,year FROM universal;";
$result = dbms_query($query);
$line = dbms_fetch_array($result, "ASSOC");
dbms_free_result($result);

echo "Tiquit version {$line['version']} Copyright {$line['year']} Jonathan Ciesla";
echo "<br />";
$time_a = array(date("H"), date("i"), date("s"));
$time = implode(":", $time_a);
$date = $date . " " . $time;
echo "$date<br />";
if($dbtype=="my"){
  echo "Running on MySQL";
  echo "<br />";
 };
if($dbtype=="pg"){
  echo "Running on PostgreSQL ";
  echo "<br />";
 };
echo "<a href=\"http://tiquit.sourceforge.net\" target=\"_blank\">Info</a>";
?>
