<?php
 /*
   Tiquit Is Quality User Incident Tracking
   Copyright (C) 2006 Jonathan Ciesla
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
  */
require_once("config.php");
require_once("functionlib.php");
authentication(0, 0);
favicon();

echo "<link rel=stylesheet href=reporting.css>";
echo "<title>Open Incidents by Group</title>";
echo "<h1>Open Incidents by Group</h1>"; 

$link = dbms_connect($dbhost, $dbuser, $dbpass, $dbname);

$grand = 0;

$query = "SELECT DISTINCT grp FROM agent ORDER BY grp ASC;";
$result = dbms_query($query);

echo "<table border=1 align=center width=600>";

while($x = dbms_fetch_array($result, "NUM")){
  $query = "SELECT COUNT(incident.number) FROM incident LEFT JOIN agent ON incident.agent = agent.number WHERE agent.grp = '{$x['0']}' AND incident.status != 'Closed';";
  $result1 = dbms_query($query);
  $line = dbms_fetch_array($result1, "NUM");
  dbms_free_result($result1);
  $count = $line[0];
  
  $grand = $grand + $count;
  
  if($count<=25){$scale=50;};
  if($count<=10){$scale=25;};
  if($count<=5){$scale=10;};
  if($count>25){$scale=100;};
  
  echo "<tr><th>{$x['0']}</th><td align=center><img src=bars.php?rating=$count&scale=$scale /></td></tr>";
 };

dbms_free_result($result);

echo "<tr><th colspan=2>Total Incidents Open: $grand</th></tr>";

echo "</table>";

echo "</html>";
?>
