<?php
 /*
   Tiquit Is Quality User Incident Tracking
   Copyright (C) 2006 Jonathan Ciesla
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
  */
require_once("config.php");
require_once("functionlib.php");
authentication(0, 0);
favicon();

$link = dbms_connect($dbhost, $dbuser, $dbpass, $dbname);

echo "<link rel=stylesheet href=css.php>";
echo "<title>$sitetitle</title>";
echo "<h1>$sitetitle</h1>";

echo "<h2>Reporting</h2>";

echo "<table border=1 align=center>";

echo "<tr><th>Text Reports</th><th colspan=2>Graphical Reports</th></tr>";

echo "<tr><td><table align=center>";

//Incident
echo "<tr><td align=center>";
echo "<form action=report_incident.php method=post target=\"_blank\">";
echo "<input type=submit value=Incident>";
echo "<input type=text name=incidenttext size=5 />";
$query = "SELECT number FROM incident ORDER BY number DESC LIMIT 10";
$result = dbms_query($query);
echo "<select name=incident>";
echo "<option value =\"\">";
while($line = dbms_fetch_array($result, "NUM")){
  echo "<option value={$line['0']}>{$line['0']}";
 };
dbms_free_result($result);
echo "</select>";
echo "</form>";
echo "</td></tr>";
//User
echo "<tr><td align=center>";
echo "<form action=name_select.php method=post target=\"_blank\">";
echo "<input type=hidden name=form value=reportuser>";
echo "<input type=submit value=User>";
name_widget(0);
echo "</form>";
echo "</td></tr>";

//Agent
echo "<tr><td align=center>";
echo "<form action=report_agent.php method=post target=\"_blank\">";
echo "<input type=submit value=Agent>";

echo "<select name=name />";
echo "<option value=\"\">Name:";
$query = "SELECT name,number FROM agent ORDER BY name ASC;";
$result = dbms_query($query, $link);
while ($line = dbms_fetch_array($result, "NUM")) {
  echo "<option value={$line['1']}>{$line['0']}";
 };
dbms_free_result($result);

echo "</select>";
echo "</form>";
echo "</td></tr>";

echo "</table></td>";

echo "<td><table align=center>";

echo "<tr><td align=center>";
echo "<form action=report_open_by_agent.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Open Incidents by Agent\" />";
echo "</form>";
echo "</td></tr>";

echo "<tr><td align=center>";
echo "<form action=report_open_by_user.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Open Incidents by User\" />";
echo "</form>";
echo "</td></tr>";

echo "<tr><td align=center>";
echo "<form action=report_open_by_location.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Open Incidents by Location\" />";
echo "</form>";
echo "</td></tr>";

echo "<tr><td align=center>";
echo "<form action=report_open_by_type.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Open Incidents by Type\" />";
echo "</form>";
echo "</td></tr>";

echo "<tr><td align=center>";
echo "<form action=report_open_by_dept.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Open Incidents by Department\" />";
echo "</form>";
echo "</td></tr>";

echo "<tr><td align=center>";
echo "<form action=report_open_by_group.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Open Incidents by Group\" />";
echo "</form>";
echo "</td></tr>";

echo "</table></td>";

echo "<td><table align=center>";

echo "<tr><td align=center>";
echo "<form action=report_closed_by_agent.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Incidents Closed by Agent\" />";
echo "Start:<input type=text name=start size=10> End:<input type=text name=end size=10>";
echo "</form>";
echo "</td></tr>";

echo "<tr><td align=center>";
echo "<form action=report_closed_by_user.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Incidents Closed by User\" />";
echo "Start:<input type=text name=start size=10> End:<input type=text name=end size=10>";
echo "</form>";
echo "</td></tr>";

echo "<tr><td align=center>";
echo "<form action=report_closed_by_location.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Incidents Closed by Location\" />";
echo "Start:<input type=text name=start size=10> End:<input type=text name=end size=10>";
echo "</form>";
echo "</td></tr>";

echo "<tr><td align=center>";
echo "<form action=report_closed_by_type.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Incidents Closed by Type\" />";
echo "Start:<input type=text name=start size=10> End:<input type=text name=end size=10>";
echo "</form>";
echo "</td></tr>";

echo "<tr><td align=center>";
echo "<form action=report_closed_by_dept.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Incidents Closed by Department\" />";
echo "Start:<input type=text name=start size=10> End:<input type=text name=end size=10>";
echo "</form>";
echo "</td></tr>";

echo "<tr><td align=center>";
echo "<form action=report_closed_by_group.php method=post target=\"_blank\">";
echo "<input type=submit value=\"Incidents Closed by Group\" />";
echo "Start:<input type=text name=start size=10> End:<input type=text name=end size=10>";
echo "</form>";
echo "</td></tr>";

echo "</table></td></tr>";

echo "</table>";

echo "<br />";
echo "<form action=main.php method=post>";
echo "<input type=submit value=Back />";
echo "</form>";
echo "</html>";
?>